<?php
/**
 * @copyright	Copyright (C) 2011 Simplify Your Web, Inc. All rights reserved.
 * @license		GNU General Public License version 3 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;

jimport('joomla.application.categories');

class modTrombinoscopeHelper
{	
	protected static $lookup;
	
	static function getParams(&$params)
	{
		$params->def('count', '');
		$params->def('category', '');
		$params->def('cat_order', '');
		$params->def('order', 'cd.ordering');
		$params->def('address_format', 'zss');
		
		$params->def('field1', 'none');
		$params->def('field2', 'none');
		$params->def('field3', 'none');
		$params->def('field4', 'none');
		$params->def('field5', 'none');
		
		$categories = "";
		$categories_array = $params->get('category', array());
		$i = 0;
		foreach ($categories_array as $category) {
			$categories = $categories.$category;
			$i++;
			if ($i < count($categories_array)) {
				$categories = $categories.',';
			}		
		}
			
		if (empty($categories)) {
			$rows = modTrombinoscopeHelper::getDefaultCategory();
			foreach($rows as $row) {
				$categories = $row->id;
			}
		}
		
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		
		// get database
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		
		$subquery = ' CASE WHEN ';
		$subquery .= $query->charLength('cd.alias');
		$subquery .= ' THEN ';
		$cd_id = $query->castAsChar('cd.id');
		$subquery .= $query->concatenate(array($cd_id, 'cd.alias'), ':');
		$subquery .= ' ELSE ';
		$subquery .= $cd_id.' END AS slug';
		
		$subquery2 = ' CASE WHEN ';
		$subquery2 .= $query->charLength('cc.alias');
		$subquery2 .= ' THEN ';
		$cc_id = $query->castAsChar('cc.id');
		$subquery2 .= $query->concatenate(array($cc_id, 'cc.alias'), ':');
		$subquery2 .= ' ELSE ';
		$subquery2 .= $cc_id.' END AS catslug';
				
		$subqueryfield1 = modTrombinoscopeHelper::getSubQuery($params->get('field1'), $params->get('address_format'), '1');
		$subqueryfield2 = modTrombinoscopeHelper::getSubQuery($params->get('field2'), $params->get('address_format'), '2');
		$subqueryfield3 = modTrombinoscopeHelper::getSubQuery($params->get('field3'), $params->get('address_format'), '3');
		$subqueryfield4 = modTrombinoscopeHelper::getSubQuery($params->get('field4'), $params->get('address_format'), '4');
		$subqueryfield5 = modTrombinoscopeHelper::getSubQuery($params->get('field5'), $params->get('address_format'), '5');
		
		//$query->select('cd.id, cd.catid, cd.name, cd.image,'.$subquery.','.$subquery2.','.$subquery3.','.$subquery4.$subqueryfield1.$subqueryfield2.$subqueryfield3.$subqueryfield4.$subqueryfield5);	
		$query->select('cd.id, cd.catid, trim(cd.name) as name, cd.image,'.$subquery.','.$subquery2.$subqueryfield1.$subqueryfield2.$subqueryfield3.$subqueryfield4.$subqueryfield5);
		
		$query->from('#__contact_details AS cd');
		$query->join('INNER', '#__categories AS cc ON cd.catid = cc.id');
		$query->where('cd.catid IN ('.$categories.')');
		
		$nullDate = $db->Quote($db->getNullDate());
		$nowDate = $db->Quote(JFactory::getDate()->toSql());
		$query->where('cd.published = 1');
		$query->where('(cd.publish_up = ' . $nullDate . ' OR cd.publish_up <= ' . $nowDate . ')');
		$query->where('(cd.publish_down = ' . $nullDate . ' OR cd.publish_down >= ' . $nowDate . ')');
				
		$query->where('cd.access IN ('.$groups.')');
		$query->where('cc.access IN ('.$groups.')');		
		
		$order = $params->get('order');
		switch ($order) {
			case 'cd.ordering ASC' :
			case 'cd.ordering DESC' :
			case 'cd.name ASC' :
			case 'cd.name DESC' : 
				$query->order($params->get('cat_order').','.$order);
				break;
			default:
				$query->order($params->get('cat_order'));
				break;
		}
		
		if (intval($params->get('count')) > 0) {
			$db->setQuery($query, 0, intval($params->get('count'))); 
		} else {
			$db->setQuery($query);
		}
		
		//echo $query->__toString();
		
		$list = $db->loadObjectList();
		
		if ($error = $db->getErrorMsg()) {
			throw new Exception($error);
		}
		
		foreach ($list as $item) {
			$item->firstpart = self::_substring_index($item->name, ' ', 1);
			$item->lastpart = self::_substring_index($item->name, ' ', -1);
		}
		
		switch ($order) {
			case 'lastpart ASC,firstpart ASC' : usort($list, "modTrombinoscopeHelper::sortLNascFNasc"); break;
			case 'lastpart DESC,firstpart DESC' : usort($list, "modTrombinoscopeHelper::sortLNdescFNdesc"); break;
			case 'firstpart ASC,lastpart ASC' : usort($list, "modTrombinoscopeHelper::sortFNascLNasc"); break;
			case 'firstpart DESC,lastpart DESC' : usort($list, "modTrombinoscopeHelper::sortFNdescLNdesc"); break;
			default: break;
		}
		
		return $list;
	}
	
	/* sort by lastname ASC firstname ASC */
	protected static function sortLNascFNasc($a, $b) {
		
		if ($a->lastpart == $b->lastpart) {        	
			if ($a->firstpart == $b->firstpart) {
				return 0;
			}
			return ($a->firstpart < $b->firstpart) ? -1 : 1;
    	}
    	return ($a->lastpart < $b->lastpart) ? -1 : 1;
	}
	
	/* sort by lastname DESC firstname DESC */
	protected static function sortLNdescFNdesc($a, $b) {
	
		if ($a->lastpart == $b->lastpart) {			 
			if ($a->firstpart == $b->firstpart) {
				return 0;
			}
			return ($a->firstpart > $b->firstpart) ? -1 : 1;
		}
		return ($a->lastpart > $b->lastpart) ? -1 : 1;
	}
	
	/* sort by firstname ASC lastname ASC */
	protected static function sortFNascLNasc($a, $b) {
	
		if ($a->firstpart == $b->firstpart) {			 
			if ($a->lastpart == $b->lastpart) {
				return 0;
			}				
			return ($a->lastpart < $b->lastpart) ? -1 : 1;
		}
		return ($a->firstpart < $b->firstpart) ? -1 : 1;
	}
	
	/* sort by firstname DESC lastname DESC */
	protected static function sortFNdescLNdesc($a, $b) {
	
		if ($a->firstpart == $b->firstpart) {			 
			if ($a->lastpart == $b->lastpart) {
				return 0;
			}
			return ($a->lastpart > $b->lastpart) ? -1 : 1;
		}
		return ($a->firstpart > $b->firstpart) ? -1 : 1;
	}
	
	static function getSubQuery($field, $format, $index)
	{		
		$subquery = '';
		
		if ($field != "none") {
			$subquery .= ', ';
			if ($field == "empty") {
				$subquery .= "'empty' AS field".$index.", 'empty' AS fieldname".$index;
			} else if ($field == "formattedaddress") {
		
				$subqueryformattedaddress = '';
				
				switch ($format) {
					case 'ssz' :
						$subqueryformattedaddress = "CONCAT(cd.suburb, ', ', cd.state, ' ', cd.postcode)";
						break;
					case 'zss' :
						$subqueryformattedaddress = "CONCAT(cd.postcode, ' ', cd.suburb, ', ', cd.state)";
						break;
					case 'zs' :
						$subqueryformattedaddress = "CONCAT(cd.postcode, ' ', cd.suburb)";
						break;
					case 'sz' :
						$subqueryformattedaddress = "CONCAT(cd.suburb, ' ', cd.postcode)";
						break;
					case 'ss' :
						$subqueryformattedaddress = "CONCAT(cd.suburb, ', ', cd.state)";
						break;						
					default :
						$subqueryformattedaddress = '';
					break;
				}
				
				$subquery .= $subqueryformattedaddress." AS field".$index.", 'formattedaddress' AS fieldname".$index;
			} else {
				$subquery .= $field." AS field".$index.", '".$field."' AS fieldname".$index;
			}
		}
				
		return $subquery;
	}

	static function getDefaultCategory()
	{
		// get database
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		
		$query->select('id');
		$query->from('#__categories');
		$query->where("alias='uncategorised'");
		$query->where("extension='com_contact'");
		
		$db->setQuery($query);
		$list = $db->loadObjectList();
		
		return $list;
	}
	
	static function getFieldOutput($field, $fieldname, $keepspace, $index) 
	{		
		$html = '';
				
		// field is empty (null) if 'none' is selected or no information has been found in the database, except for formatted address...
		
		if ($fieldname == "formattedaddress") { // trim the field if it contains nothing 
			$elements = preg_split ('/[\s]*[,][\s]*/', $field); // deals with "elt1  ,elt2,   elt3  "
				
			$i = 0;
			$unique_element = '';
			foreach ($elements as $element) {
				if (!empty($element)) {
					$unique_element = $element;
					$i++;
				}
			}
			// to avoid commas or spaces if missing info
			if ($i == 0) {
				$field = '';
			} else if ($i == 1) {
				$field = $unique_element;
			}	
		}
		
		if (!empty($field)) {
			$html .= '<div class="personfield'.$index.'">';
			
			switch ($fieldname) {
				case 'cd.con_position' :
					$html .= '    <span class="personposition">'.$field.'</span>';
					break;
				case 'cd.telephone' :
					$html .= '    <span class="persontel">'.$field.'</span>';
					break;
				case 'cd.mobile' :
					$html .= '    <span class="personmobile">'.$field.'</span>';
					break;
				case 'cd.fax' :
					$html .= '    <span class="personfax">'.$field.'</span>';
					break;
				case 'cd.email_to' :
					$html .= '    <a class="personemail" href="mailto:'.$field.'" title="'.$field.'">';
					$html .= '        <span>'.$field.'</span>';
					$html .= '    </a>';
					break;
				case 'cd.webpage' :
					$html .= '    <a class="personwebpage" href="'.$field.'" target="_blank" title="'.$field.'">';
					$html .= '        <span>'.$field.'</span>';
					$html .= '    </a>';
					break;
				case 'cd.address' :
					$html .= '    <span class="personaddress">'.$field.'</span>';
					break;
				case 'cd.suburb' :
					$html .= '    <span class="personsuburb">'.$field.'</span>';
					break;
				case 'cd.state' :
					$html .= '    <span class="personstate">'.$field.'</span>';
					break;
				case 'cd.country' :
					$html .= '    <span class="personcountry">'.$field.'</span>';
					break;
				case 'cd.misc' :
					$html .= '    <div class="personmiscinfo">'.$field.'</div>';
					break;
				case 'formattedaddress' :
					$html .= '    <span class="personformattedaddress">'.$field.'</span>';
					break;
				default :
					$html .= '    <span class="_empty">&nbsp;</span>'; // 'empty' field
					break;
			}
			
			$html .= '</div>';
		} else if ($keepspace) {
			$html .= '<div class="personfield'.$index.'">';			
			
			switch ($fieldname) {
				case 'cd.con_position' :
					$html .= '    <span class="personposition_empty">&nbsp;</span>';
					break;
				case 'cd.telephone' :
					$html .= '    <span class="persontel_empty">&nbsp;</span>';
					break;
				case 'cd.mobile' :
					$html .= '    <span class="personmobile_empty">&nbsp;</span>';
					break;
				case 'cd.fax' :
					$html .= '    <span class="personfax_empty">&nbsp;</span>';
					break;
				case 'cd.email_to' :
					$html .= '    <span class="personemail_empty">&nbsp;</span>';
					break;
				case 'cd.webpage' :
					$html .= '    <span class="personwebpage_empty">&nbsp;</span>';
					break;
				case 'cd.address' :
					$html .= '    <span class="personaddress_empty">&nbsp;</span>';
					break;
				case 'cd.suburb' :
					$html .= '    <span class="personsuburb_empty">&nbsp;</span>';
					break;
				case 'cd.state' :
					$html .= '    <span class="personstate_empty">&nbsp;</span>';
					break;
				case 'cd.country' :
					$html .= '    <span class="personcountry_empty">&nbsp;</span>';
					break;
				case 'cd.misc' :
					$html .= '    <div class="personmiscinfo_empty">&nbsp;</div>';
					break;
				case 'formattedaddress' :
					$html .= '    <span class="personformattedaddress_empty">&nbsp;</span>';
					break;				
				default :
					break;
			}	
			
			$html .= '</div>';
		}				
		
		return $html;
	}
	
	/**
	* Create the contact link
	*/
	public static function getContactRoute($id, $catid, $extraoptions = '')
	{
		$needles = array(
			'contact'  => array((int) $id)
		);

		$link = 'index.php?option=com_contact&view=contact&id='.$id.$extraoptions;
		if ($catid > 1) {
			$categories = JCategories::getInstance('Contact');
			$category = $categories->get($catid);
			if ($category) {
				$needles['category'] = array_reverse($category->getPath());
				$needles['categories'] = $needles['category'];
				$link .= '&catid='.$catid;
			}
		}
		
		if ($item = self::_findItem($needles)) {
			$link .= '&Itemid='.$item;
		} elseif ($item = self::_findItem()) {
			$link .= '&Itemid='.$item;
		} else {
			$link .= '&Itemid=0';
		}
	
		return $link;
	}
	
	protected static function _findItem($needles = null)
	{
		$app		= JFactory::getApplication();
		$menus		= $app->getMenu('site');
	
		// Prepare the reverse lookup array.
		if (self::$lookup === null) {
			self::$lookup = array();
	
			$component	= JComponentHelper::getComponent('com_contact');
			$items		= $menus->getItems('component_id', $component->id);
			if ($items != null) {			
				foreach ($items as $item) {
					if (isset($item->query) && isset($item->query['view'])) {
						$view = $item->query['view'];
						if (!isset(self::$lookup[$view])) {
							self::$lookup[$view] = array();
						}
						if (isset($item->query['id'])) {
							self::$lookup[$view][$item->query['id']] = $item->id;
						}
					}
				}
			}
		}
	
		if ($needles) {
			foreach ($needles as $view => $ids) {
				if (isset(self::$lookup[$view])) {
					foreach($ids as $id) {
						if (isset(self::$lookup[$view][(int)$id])) {
							return self::$lookup[$view][(int)$id];
						}
					}
				}
			}
		} 
	
		return null;
	}
	
	protected static function _substring_index($subject, $delim, $count)
	{
	    if ($count < 0) {
	        return implode($delim, array_slice(explode($delim, $subject), $count));
	    } else {
	        return implode($delim, array_slice(explode($delim, $subject), 0, $count));
	    }
	}

}
