<?php
/**
 * @copyright	Copyright (C) 2011 Simplify Your Web, Inc. All rights reserved.
 * @license		GNU General Public License version 3 or later; see LICENSE.txt
 */
 
// no direct access
defined('_JEXEC') or die;

require_once(JPATH_SITE.DS.'modules'.DS.'mod_trombinoscope'.DS.'helper.php');

$photo_align = $params->get('photo_align');

$default_picture = $params->get('default_picture', '');
if (!empty($default_picture)) {
	$default_picture = JURI::base().$default_picture;
}

$keep_space = $params->get('keepspace');
$show_link = $params->get('linktocontact');

$popup_x = $params->get('popup_x', '600');
$popup_y = $params->get('popup_y', '500');

$link_text = $params->get('link');
$format_style = $params->get('name_format');

$class = htmlspecialchars($params->get('moduleclass_sfx'));
$class_suffix = (empty($class)) ? $module->id : trim($class);

$urlPath = JURI::base()."modules/mod_trombinoscope/";
$document = JFactory::getDocument();
$document->addStyleSheet($urlPath."style.css.php?suffix=".$class_suffix);

$i = 0;
$oddoreven = "even";
?>

<div class="trombinoscope_<?php echo $class_suffix; ?> personlist">
<?php foreach ($list as $item) : ?>	
	
	<?php	
		// link
		//$link = JRoute::_('index.php?option=com_contact&view=contact&id='.$item->slug.'&catid='.$item->catslug.'&Itemid='.$params->get('menulink'));
		//$link = JRoute::_(ContactHelperRoute::getContactRoute($item->slug, $item->catid));
			
		$link = '';
		$extra_attributes = '';	
		switch ($show_link) {
			case 'standard' :
				$link = htmlspecialchars(modTrombinoscopeHelper::getContactRoute($item->slug, $item->catslug));
				break;
			case 'popup' : // open in a modal window
				$link = htmlspecialchars(modTrombinoscopeHelper::getContactRoute($item->slug, $item->catslug, '&tmpl=component'));
				JHtml::_('behavior.modal', 'a.modal');
				$extra_attributes = 'class="modal" rel="{handler: \'iframe\', size: {x:'.$popup_x.', y:'.$popup_y.'}}"';
				break;
			default :
				$show_link = '';
				break;
		}
	
		// name format
		$formatted_name = $item->name;
		if ($format_style == "lastspacefirst") {
			if (!empty($item->lastpart)) {
				$formatted_name = $item->lastpart." ".$item->firstpart;
			} else {
				$formatted_name = $item->firstpart;
			}
		} else if ($format_style == "firstspacelast") {
			if (!empty($item->firstpart)) {
				$formatted_name = $item->firstpart." ".$item->lastpart;
			} else {
				$formatted_name = $item->lastpart;
			}
		} else if ($format_style == "lastcomafirst") {
			if (!empty($item->lastpart)) {
				$formatted_name = $item->lastpart.", ".$item->firstpart;
			} else {
				$formatted_name = $item->firstpart;
			}
		} else if ($format_style == "firstcomalast") {
			if (!empty($item->firstpart)) {
				$formatted_name = $item->firstpart.", ".$item->lastpart;
			} else {
				$formatted_name = $item->lastpart;
			}
		}
	
		// picture positioning
		if ($params->get('photo_align') == "alternate") {
			if ($i % 2) {
				$photo_align = "left";
			} else {
				$photo_align = "right";
			}
		} 
		if ($i % 2) {
			$oddoreven = "even";
		} else {
			$oddoreven = "odd";
		}
		$i++;
	?>
	
	<div class="person">
		<div class="innerperson <?php echo $oddoreven; ?>">
			<div class="personpicture" style="float: <?php echo $photo_align ?>">
				<?php if ($show_link) : ?>			
					<a <?php echo $extra_attributes; ?> href="<?php echo $link; ?>" title="<?php echo $formatted_name; ?>" >
						<?php if (!empty($item->image)) : ?>			
							<?php echo JHTML::_('image', $item->image, $link_text, array('class' => 'personpictureimg')); ?>
						<?php elseif (!empty($default_picture)) : ?>
							<?php echo JHTML::_('image', $default_picture, $link_text, array('class' => 'personpictureimg')); ?>
						<?php else : ?>
							<span class="nopicture">&nbsp;</span>
						<?php endif; ?>
					</a>
				<?php else : ?>
					<?php if (!empty($item->image)) : ?>
						<?php echo JHTML::_('image', $item->image, $link_text, array('class' => 'personpictureimg')); ?>
					<?php elseif (!empty($default_picture)) : ?>
						<?php echo JHTML::_('image', $default_picture, $link_text, array('class' => 'personpictureimg')); ?>
					<?php else : ?>
						<span class="nopicture">&nbsp;</span>
					<?php endif; ?>				
				<?php endif; ?>
			</div>
			<div class="personinfo <?php echo $photo_align ?>">				
				<?php if (empty($link_text) && $show_link) : ?>
					<div class="personname">
						<a <?php echo $extra_attributes; ?> href="<?php echo $link; ?>" title="<?php echo $formatted_name; ?>" >
							<span><?php echo $formatted_name; ?></span>
						</a>
					</div>
				<?php else : ?>
					<div class="personname"><?php echo $formatted_name; ?></div>
				<?php endif; ?>				
				
				<?php 
					if (!empty($item->fieldname1)) { echo modTrombinoscopeHelper::getFieldOutput($item->field1, $item->fieldname1, $keep_space, 1);	}			
					if (!empty($item->fieldname2)) { echo modTrombinoscopeHelper::getFieldOutput($item->field2, $item->fieldname2, $keep_space, 2);	}			
					if (!empty($item->fieldname3)) { echo modTrombinoscopeHelper::getFieldOutput($item->field3, $item->fieldname3, $keep_space, 3);	}			
					if (!empty($item->fieldname4)) { echo modTrombinoscopeHelper::getFieldOutput($item->field4, $item->fieldname4, $keep_space, 4);	}			
					if (!empty($item->fieldname5)) { echo modTrombinoscopeHelper::getFieldOutput($item->field5, $item->fieldname5, $keep_space, 5); }
				?>	
					
				<?php if (!empty($link_text) && $show_link) : ?>					
					<div class="personlink">
						<a <?php echo $extra_attributes; ?> href="<?php echo $link; ?>" title="<?php echo $link_text; ?>" >
							<span><?php echo $link_text; ?></span>
						</a>
					</div>
				<?php endif; ?>
			</div>
		</div>
	</div>
<?php endforeach; ?>
</div>
